unit Unit1;

{
 research color compression from 8 to 4 bits
 simple rounding: code 0 -> $0f ....... 15 -> $ff
 smart rounding : via value table, generated by polynomial

 purpose is image compression by using smaller color numbers.
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls,jpeg;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    PaintBox1: TPaintBox;
    PaintBox2: TPaintBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    SpeedButton5: TSpeedButton;
    Button5: TButton;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const vcolors : array[0..1] of dword = ($00e0ff,$00b0ff);

type PDW = ^dword;

var orgBM, roundBM, smartBM : TBitmap;
    orgBase : dword;
    orgDy   : dword;
    rBase   : dword;
    rDy     : dword;
    sBase   : dword;
    sDy     : dword;
    basevalue : array[0..15] of byte;
    penvalue  : array[0..15] of byte;
    A,B,C   : double;
    x1,y1,x2,y2,x3,y3 : byte;

function findIndex(x : byte) : byte;
//find closest index in basevalue array for x
var base,range : byte;
begin
 base := 0;
 range := 8;
 while range > 0 do
  begin
   if x >= basevalue[base+range] then base := base + range;
   range := range shr 1;
  end;
 result := base; 
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 orgBM := Tbitmap.create;
 with orgBM do
  begin
   width := 513;
   height := 513;
   pixelformat := pf32bit;
   orgBase := dword(scanline[0]);
   orgDy   := orgBase- dword(scanline[1]);
  end;
 roundBM := TBitmap.create;
 with roundBM do
  begin
   width := 513;
   height := 513;
   pixelformat := pf32bit;
   rBase := dword(scanline[0]);
   rDy   := rBase- dword(scanline[1]);
  end;
 smartBM := TBitmap.create;
 with smartBM do
  begin
   width := 513;
   height := 513;
   pixelformat := pf32bit;
   sBase := dword(scanline[0]);
   sDy   := sBase- dword(scanline[1]);
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 orgBM.free;
 roundBM.Free;
 smartBM.Free;
end;

procedure paintedges(pb:TPaintbox);
//paint on canvas of form1
var i : byte;
    x1,y1,x2,y2 : word;
begin
 with form1 do with canvas do
  begin
   x1 := pb.left - 2;
   y1 := pb.Top - 2;
   x2 := pb.Left + pb.Width + 1;
   y2 := pb.Top + pb.height + 1;
   for i := 0 to 1 do
    begin
     pen.Color := $0;
     moveto(x2-i,y1+i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     pen.color := $808080;
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
    end;
  end;
end;

procedure showvalues;
//paint conversion tabel in paintbox2
var i,x,y : longInt;
begin
 form1.speedbutton5.Down := true;
 with form1.PaintBox2 do with canvas do
  begin
   brush.style := bsSolid;
   brush.Color := $ffffff;
   fillrect(rect(0,0,width,height));             //erase
   for i := 0 to 511 do         //vertical lines
    begin
     x := i shr 1;              //color value
     y := findindex(x);
     pen.Color := vcolors[y and 1];
     moveto(i,512);
     lineto(i,512-y*32);
    end;
   pen.Width := 1;
   pen.Color := $ffe0e0;
   i := 0;
   while i < width do          //horizontal
    begin
     moveto(0,i);
     lineto(width,i);
     inc(i,32);
    end;
  i := 0;
  while i < height do         //vertical
   begin
    if i mod 100 = 0 then pen.Color := $ff0000 else pen.Color := $ffe0e0;
    moveto(i,0);
    lineto(i,height);
    inc(i,20);
   end;
  pen.color := $0;
  moveto(0,512);             //graphics
  for i := 1 to 15 do lineto(trunc(2*(A*sqr(i) + B*i + C)),512-32*i);
  brush.style := bsClear;
  font.Name := 'arial';
  font.Height := 16;
  font.color := 0;
  for i := 0 to 15 do textout(5,496 - 32*i,inttostr(i)); //codes
  for i := 1 to 4 do textout(100*i+5,490,inttostr(50*i));  //values
  end; //with
end;

// ----

procedure setXY;
begin
 with form1 do
  begin
   x1 := strtoint(edit1.Text);
   y1 := strtoint(edit2.Text);
   x2 := strtoint(edit3.Text);
   y2 := strtoint(edit4.Text);
   x3 := strtoint(edit5.Text);
   y3 := strtoint(edit6.Text);
  end;
end;

procedure makeABC;
var p,q,r,s,t,u : double;
begin
 p := sqr(x1)-sqr(x2);
 q := x1-x2;
 r := sqr(x2)-sqr(x3);
 s := x2-x3;
 t := y1-y2;
 u := y2-y3;
 A := (t*s - u*q)/(p*s - r*q);
 B := (t- A*p)/q;
 C := y1 - A*sqr(x1) - B*x1;
end;

procedure makebasevalues;
var i : byte;
begin
 for i := 1 to 15 do baseValue[i] := trunc(a*sqr(i) + B*i + C);
 baseValue[0] := 0;
end;

procedure makePenValues;
var i : byte;
begin
 for i := 0 to 14 do penValue[i] := (baseValue[i] + baseValue[i+1] + 3) shr 1;
 penvalue[15] := $ff;
end;

procedure TForm1.Button2Click(Sender: TObject);
//make value tables
begin
 setXY;
 makeABC;
 makebasevalues;
 makePenValues;
 showValues;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 paintedges(paintbox1);
 paintedges(paintbox2);
end;

procedure TForm1.Button1Click(Sender: TObject);
var fext : string;
 jpegImage : TJpegImage;
 bm : Tbitmap;
begin
 with opendialog1 do
  if execute then
   begin
    fext := ExtractFileExt(filename);
    if fext = '.bmp' then
     begin
      bm := Tbitmap.Create;
      bm.LoadFromFile(filename);
      orgBM.canvas.Draw(0,0,bm);
      bm.Free;
     end;
    if fext = '.jpg' then
     begin
      jpegImage := TJpegImage.create;
      jpegImage.loadfromFile(filename);
      orgBM.canvas.draw(0,0,jpegImage);
      jPegImage.free;
     end;
    paintbox1.Canvas.draw(0,0,orgBM);
    speedbutton1.Down := true;
   end;
end;

procedure TForm1.Button3Click(Sender: TObject);
//round colors and write rBM,sBM bitmaps
var x,y,x4 : word;
    orgline,rline,sline,pix,rpix,spix : dword;
    r,g,b,rr,rg,rb,sr,sg,sb : byte;
begin
 for y := 0 to orgBM.Height-1 do
  begin
   orgline := orgBase - y*orgDy;
   rline := rBase - y*rDy;
   sline := sBase - y*sDy;
   for x := 0 to orgBM.Width-1 do
    begin
     x4 := x shl 2;
     pix := PDW(orgline + x4)^;    //extract colors
     r := (pix shr 16) and $ff;
     g := (pix shr 8) and $ff;
     b := pix and $ff;
     if r < $8 then r := $8;
     if g < $8 then g := $8;
     if b < $8 then b := $8;

     rr := (r - $7) or $f;
     rg := (g - $7) or $f;
     rb := (b - $7) or $f;
     rpix := (rr shl 16) or (rg shl 8) or rb;
     PDW(rline + x4)^ := rpix;
//
     sr := penvalue[findIndex(r)]; //make smart values
     sg := penvalue[findIndex(g)];
     sb := penvalue[findIndex(b)];
     spix := (sr shl 16) or (sg shl 8) or sb;
     PDW(sline + x4)^ := spix;
    end;
  end;
 if speedbutton3.Down then paintbox2.Canvas.Draw(0,0,roundBM);
 if speedbutton4.down then paintbox2.Canvas.Draw(0,0,smartBM);
end;

procedure TForm1.Button5Click(Sender: TObject);
//make demo image in orgBM
var x,y : word;
    r,g,b,quad: byte;
    line,pix : dword;
begin
 for y := 0 to orgBM.Height-1 do
  begin
   line := orgBase - y*orgDy;
   for x := 0 to orgBM.Width-1 do
    begin
     quad := ((x and $100) shr 8) + ((y and $100) shr 7);
     case quad of
      0 : begin
           r := y and $ff;
           g := 0;
           b := 0;
          end;
      1 : begin
           r := y and $ff;
           g := x and $ff;
           b := 0;
          end;
      2 : begin
           r := y and $ff;
           g := (x + 7) and $ff;
           b := 0;
          end;
      3 : begin
           r := (x+y) and $ff;
           g := r;
           b := r;
          end;
      else begin r := 0; g := 0; b := 0; end;
     end;
     pix := (r shl 16) + (g shl 8) + b;
     PDW(line + (x shl 2))^ := pix;
    end;
  end;
 paintbox1.Canvas.Draw(0,0,orgBM);
 speedbutton1.Down := true;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
 case TSpeedButton(sender).Tag of
  1 : paintbox1.Canvas.Draw(0,0,orgBM);
  2 : paintbox1.Canvas.Draw(0,0,roundBM);
  3 : paintbox2.Canvas.Draw(0,0,roundBM);
  4 : paintbox2.Canvas.Draw(0,0,smartBM);
  5 : showvalues;
 end;
end;


end.
